# Colight

Colight is a Python library for creating interactive, JavaScript-based visuals. It provides a simple, composable way to generate plots, animations, and custom user interfaces from within a Python environment.

[Getting Started](quickstart.py){ .md-button  .md-button--primary }

Key features:

- Seamless integration with [Observable Plot](https://observablehq.com/plot/), a layered grammar-of-graphics based library, for creating rich, interactive plots
- Compose plots, HTML elements, and interactive widgets using a simple, declarative syntax
- Animate plots with built-in support for sliders and frame-by-frame animations
- Embed visuals in Jupyter notebooks or standalone HTML files
- Customize every aspect of your visuals with JavaScript when needed

### Installation

To install Colight, run

```bash
pip install colight
```
